package assets.screens
{
   import assets.effects.star1;
   import flash.display.*;
   import flash.events.*;
   import flash.net.SharedObject;
   import flash.text.TextField;
   
   [Embed(source="/_assets/assets.swf", symbol="assets.screens.screen_stats")]
   public class screen_stats extends MovieClip
   {
       
      
      public var recoveryRate:Number = 0.5;
      
      public var bails:Number = 0;
      
      public var continueBtn:SimpleButton;
      
      public var action:Boolean = true;
      
      public var score_txt:TextField;
      
      public var staminabar:MovieClip;
      
      private var scope:Object;
      
      public var paused_mc:MovieClip;
      
      public var speed:Number = 0;
      
      private var sboard:Array;
      
      public var stamina:Number = 1;
      
      public var speedbar:MovieClip;
      
      public var muteBtn:MovieClip;
      
      public var localScores:MovieClip;
      
      public var trickFX:MovieClip;
      
      public var travelBar:MovieClip;
      
      public var bailBonus:MovieClip;
      
      public var saveBtn:SimpleButton;
      
      public var score:Number = 0;
      
      public var pauseBtn:MovieClip;
      
      private var sObj:SharedObject;
      
      public var bails_txt:TextField;
      
      public var restartBtn:SimpleButton;
      
      public var bailBonusQty:Number = 2;
      
      public var trickScore:Number = 0;
      
      public function screen_stats(param1:*)
      {
         action = true;
         score = 0;
         bails = 0;
         bailBonusQty = 2;
         trickScore = 0;
         trickFX = new trickText();
         speed = 0;
         stamina = 1;
         recoveryRate = 0.5;
         sboard = new Array();
         super();
         scope = param1;
         trickFX.x = 350;
         trickFX.y = 100;
         trickFX.tscore_txt.text = 0;
         trickFX.visible = false;
         addChild(trickFX);
         restartBtn.addEventListener(MouseEvent.CLICK,restartGame);
         saveBtn.addEventListener(MouseEvent.CLICK,saveScreen);
         continueBtn.addEventListener(MouseEvent.CLICK,continueGame);
         muteBtn.addEventListener(MouseEvent.CLICK,muteSounds);
         pauseBtn.addEventListener(MouseEvent.CLICK,pauseGame);
         paused_mc.visible = false;
         localScores.saveBtn.addEventListener(MouseEvent.CLICK,saveScore);
         localScores.doneBtn.addEventListener(MouseEvent.CLICK,doneScore);
         localScores.visible = false;
         setScoreData();
         gameOverMenu(false);
         courseCompleteMenu(false);
      }
      
      public function pauseGame(param1:Event) : *
      {
         if(action)
         {
            action = false;
            scope.sound.soundON = false;
            scope.sound.stopSounds();
            param1.target.gotoAndStop("off");
            paused_mc.visible = true;
         }
         else
         {
            action = true;
            scope.sound.soundON = true;
            scope.sound.restartSounds();
            param1.target.gotoAndStop("on");
            paused_mc.visible = false;
         }
      }
      
      public function courseCompleteMenu(param1:*) : *
      {
         continueBtn.visible = bailBonus.visible = param1;
      }
      
      private function setScoreData() : *
      {
         var _loc1_:* = undefined;
         sObj = SharedObject.getLocal("streetskater","/");
         _loc1_ = 0;
         while(_loc1_ < 10)
         {
            sboard.push({
               "nm":" --- ",
               "sc":0
            });
            _loc1_++;
         }
         updateBoard();
      }
      
      private function saveScore(param1:Event) : *
      {
         var _loc2_:* = undefined;
         _loc2_ = {
            "nm":localScores.pName.text,
            "sc":score
         };
         sboard.push(_loc2_);
         sboard.sortOn("sc",Array.NUMERIC | Array.DESCENDING);
         if(sboard.length > 10)
         {
            sboard.pop();
         }
         sObj.data.scores = sboard;
         sObj.flush();
         localScores.saveBtn.removeEventListener(MouseEvent.CLICK,saveScore);
         saveBtn.removeEventListener(MouseEvent.CLICK,saveScreen);
         updateBoard();
      }
      
      private function doneScore(param1:Event) : *
      {
         localScores.visible = false;
         trickFX.visible = true;
         gameOverMenu(true);
      }
      
      public function initTrickFX(param1:String) : *
      {
         trickFX.gotoAndStop(param1);
         trickFX.visible = true;
         trickFX.addEventListener(Event.ENTER_FRAME,trickMonitor);
      }
      
      private function continueGame(param1:Event) : *
      {
         courseCompleteMenu(false);
         clearTrickFX(true);
         updateBails(scope.course * bailBonusQty);
         scope.player.tscore = 0;
         travelBar.scaleX = 0;
         scope.gameContinue();
      }
      
      private function saveScreen(param1:Event) : *
      {
         gameOverMenu(false);
         trickFX.visible = false;
         updateBoard();
         localScores.visible = true;
         stage.focus = localScores.pName;
         localScores.pName.setSelection(0,0);
      }
      
      public function updateStamina(param1:*) : *
      {
         stamina += param1 / 100;
         if(stamina >= 1)
         {
            stamina = 1;
         }
         if(stamina <= 0)
         {
            stamina = 0;
         }
      }
      
      public function updateScore(param1:Number) : *
      {
         score += param1;
         score_txt.text = score.toString();
      }
      
      public function clearTrickFX(param1:Boolean) : *
      {
         if(param1)
         {
            updateScore(trickScore);
         }
         trickScore = 0;
         trickFX.visible = false;
         trickFX.removeEventListener(Event.ENTER_FRAME,trickMonitor);
      }
      
      private function submitScore(param1:Event) : *
      {
         trace("submitScores click");
      }
      
      public function resetStats() : *
      {
         gameOverMenu(false);
         score = 0;
         bails = 10;
         updateScore(0);
         updateBails(0);
         travelBar.scaleX = 0;
         localScores.saveBtn.addEventListener(MouseEvent.CLICK,saveScore);
         saveBtn.addEventListener(MouseEvent.CLICK,saveScreen);
      }
      
      public function process() : *
      {
         updateStamina(recoveryRate);
         staminabar.scaleY = stamina;
         speedbar.scaleY = scope.vx / scope.topspd;
         speedbar.gotoAndStop(1 + Math.round(speedbar.scaleY * 100 / 10));
         staminabar.gotoAndStop(1 + Math.round(stamina * 100 / 10));
      }
      
      public function trickMonitor(param1:Event) : *
      {
         trickStars();
         trickScore = scope.player.tscore;
         trickFX.tscore_txt.text = trickScore.toString();
      }
      
      private function updateBoard() : *
      {
         var _loc1_:* = undefined;
         if(sObj.data.scores == undefined)
         {
            sObj.data.scores = sboard;
         }
         else
         {
            sboard = sObj.data.scores;
         }
         sboard.sortOn("sc",Array.NUMERIC | Array.DESCENDING);
         _loc1_ = 1;
         while(_loc1_ < sboard.length + 1)
         {
            localScores["n" + _loc1_].text = sboard[_loc1_ - 1].nm;
            localScores["s" + _loc1_].text = sboard[_loc1_ - 1].sc;
            _loc1_++;
         }
         localScores.pScore.text = score.toString();
         localScores.pName.text = "";
      }
      
      private function muteSounds(param1:Event) : *
      {
         if(scope.sound.soundON)
         {
            scope.sound.soundON = false;
            scope.sound.stopSounds();
            param1.target.gotoAndStop("off");
         }
         else
         {
            scope.sound.soundON = true;
            scope.sound.restartSounds();
            param1.target.gotoAndStop("on");
         }
      }
      
      private function restartGame(param1:Event) : *
      {
         clearTrickFX(false);
         score = 0;
         scope.player.tscore = 0;
         scope.gameReset();
      }
      
      private function trickStars() : *
      {
         var _loc1_:MovieClip = null;
         _loc1_ = new star1(trickFX,scope);
         _loc1_.x += 10 - Math.round(Math.random() * 20);
         _loc1_.y += 10 - Math.round(Math.random() * 20);
         trickFX.addChild(_loc1_);
      }
      
      public function updateBails(param1:Number) : *
      {
         bails += param1;
         bails_txt.text = bails.toString();
      }
      
      public function gameOverMenu(param1:*) : *
      {
         restartBtn.visible = saveBtn.visible = param1;
      }
   }
}
